#!/usr/bin/env python
# -*- coding:UTF-8 -*-
"""
    This file will control some options of the custom panel
    and should be something like a skeleton to begin with
    Please include a smal description of the file, so it is much
    easier for other developers to follow yozr style. there ar many 
    lasy people out there, not taking care of that, please do not become 
    one of them!

    Copyright 2013 Norbert Schechner
    nieson@web.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""

# Please read also the above text! And if you begin to code some new stuff
# please include comments, so others can follow you!

# Name varialbles so others do now there meaning, see the following example:
# v=f-s+(w.get_value)
# value = first_value - second_value + (widget.get_value)
# it cost no performanca, but is much easier to read!
# for coding style I recfommend to follow PEP8
# see : http://legacy.python.org/dev/peps/pep-0008/


####################################################################
# Watch the terminal output, as the error reports will apear there #
####################################################################

# We will need to import some basic stuff
import hal           # needed to make our own hal pins
import hal_glib      # needed to make our own hal pins and react with handlers

from gladevcp.persistence import IniFile


class GearSelect:

    # __init__ will set the defaults and get all relevant information, before showing the panel
    def __init__(self, halcomp, builder, useropts):
        self.builder = builder
        self.halcomp = halcomp

        self.defaults = { IniFile.vars : { "SelectedGear"       : 0 ,
                                         },
                        }

        self.ini_filename = __name__ + ".var"
        self.ini = IniFile(self.ini_filename, self.defaults, self.builder)
        self.ini.restore_state(self)

        self.halcomp.newpin("selected-gear", hal.HAL_S32, hal.HAL_OUT)
        self.halcomp["selected-gear"] = self.SelectedGear

        self.btn_1 = self.builder.get_object("btn-1")
        self.btn_1.connect("clicked", self._btn_1_clicked)

        self.btn_2 = self.builder.get_object("btn-2")
        self.btn_2.connect("clicked", self._btn_2_clicked)

        self.btn_3 = self.builder.get_object("btn-3")
        self.btn_3.connect("clicked", self._btn_3_clicked)

        self.btn_4 = self.builder.get_object("btn-4")
        self.btn_4.connect("clicked", self._btn_4_clicked)

        self.btn_5 = self.builder.get_object("btn-5")
        self.btn_5.connect("clicked", self._btn_5_clicked)

        self.btn_6 = self.builder.get_object("btn-6")
        self.btn_6.connect("clicked", self._btn_6_clicked)

        self.frame = self.builder.get_object("frame_main")
        self.frame.connect("destroy", self.on_frame_main_destroy)

    def _btn_1_clicked(self, Widget):
        print("Button %s has been clicked" % Widget.get_label())
        self.halcomp["selected-gear"] = 1
        self.SelectedGear = 1
        print("Hal pin has been set to %s" % self.halcomp["selected-gear"])

    def _btn_2_clicked(self, Widget):
        print("Button %s has been clicked" % Widget.get_label())
        self.halcomp["selected-gear"] = 2
        self.SelectedGear = 2
        print("Hal pin has been set to %s" % self.halcomp["selected-gear"])

    def _btn_3_clicked(self, Widget):
        print("Button %s has been clicked" % Widget.get_label())
        self.halcomp["selected-gear"] = 3
        self.SelectedGear = 3
        print("Hal pin has been set to %s" % self.halcomp["selected-gear"])

    def _btn_4_clicked(self, Widget):
        print("Button %s has been clicked" % Widget.get_label())
        self.halcomp["selected-gear"] = 4
        self.SelectedGear = 4
        print("Hal pin has been set to %s" % self.halcomp["selected-gear"])

    def _btn_5_clicked(self, Widget):
        print("Button %s has been clicked" % Widget.get_label())
        self.halcomp["selected-gear"] = 5
        self.SelectedGear = 5
        print("Hal pin has been set to %s" % self.halcomp["selected-gear"])

    def _btn_6_clicked(self, Widget):
        print("Button %s has been clicked" % Widget.get_label())
        self.halcomp["selected-gear"] = 6
        self.SelectedGear = 6
        print("Hal pin has been set to %s" % self.halcomp["selected-gear"])

    def on_frame_main_destroy(self, Widget, data = None):
        self.ini.save_state(self)
        print("Done")

# This is the main procedure in this case, please take care that the name within the return value
# is exactly the same as the Class Name, (case senstitive)
def get_handlers(halcomp, builder, useropts):
    return[GearSelect(halcomp, builder, useropts)]
